<script>
import Multiselect from "vue-multiselect";
import TimelineForm from "@components/candidate/timeline/timeline-form";
import Experience from "@src/models/user/candidate/Experience";
import store from "@state/store";
import Degree from "@src/models/user/candidate/Degree";

export default {
  name: "Timeline",
  components : { TimelineForm, Multiselect },
  props: {
    elements : null,
    baseUrl : null,
    options : {
      canEdit : false,
      type : null,
    }
  },
  data(){
    return {
      formIsShow : false,
      element : null
    }
  },
  methods : {
    addElement() {
      this.update_mode = false
      let timeline;
      if( this.type === 'experiences' ){
        timeline = new Experience({candidate_id : store.state.auth.currentUser.id})
      }else{
        timeline = new Degree({candidate_id : store.state.auth.currentUser.id})
      }
      this.timeline = timeline;
      this.formIsShow = true
    },
    editElement( timeline ) {
      this.update_mode = true
      this.timeline = timeline;
      this.formIsShow = true;
    },
    remove( element ) {
      this.$emit('remove', element )
      this.formIsShow = false;
    },
    create( element ){
      this.$emit('create', element )
      this.formIsShow = false;
    },
    update( element ){
      this.$emit('update', element )
      this.formIsShow = false;
    },
    hideForm() {
      this.formIsShow = false;
    }
  }
}
</script>

<template>
  <div>
    <ul class="list-unstyled timeline-sm">
      <li v-for="element in elements" class="timeline-sm-item">
        <span class="timeline-sm-date">{{ element.formatStartAt() }} - {{ element.formatEndAt() }}</span>
        <h5 class="mt-0 mb-1">
          {{ element.name }}
          <i v-if="options.canEdit" class="fas fa-trash float-right" style="cursor: pointer" @click="remove(element)"></i>
          <i v-if="options.canEdit" class="fas fa-pen-square mr-1 float-right" style="cursor: pointer" @click="editElement(element)"></i>
        </h5>
        <p class="text-muted mt-1">
          <span v-if="options.type === 'experiences' && element.description">{{ element.description }}</span>
          <span v-if="element.school">{{ element.school }}
            <span v-if="element.city">({{ element.city }})</span>
          </span>
          <span v-if="element.company"> - {{ element.company }}
            <span v-if="element.city">({{ element.city }})</span>
          </span>
        </p>
      </li>
    </ul>
    <div v-if="options.canEdit">
      <div v-if="!formIsShow" class="float-right">
        <b-button variant="primary" @click="addElement">Ajouter une éxpérience</b-button>
      </div>
      <div class="clearfix"></div>
      <TimelineForm
          v-if="formIsShow"
          :type="options.type"
          :timeline="timeline"
          :update_mode="update_mode"
          @create="create"
          @update="update"
          @hide="hideForm"
      ></TimelineForm>
    </div>
  </div>
</template>
